C++ Tutorial Index

C++ Tutorial C++ History C++ Installation C++ First Program C++ cin and cout C++ Data type C++ Variable C++ operator C++ Keywords

C++ Control Statements

C++ If C++ Nested if C++ If-else C++ If-else-if C++ Switch C++ Break C++ Continue C++ Goto C++ For loop C++ While loop C++ Do while loop

C++ Functions

C++ Call by Value C++ Call by Reference C++ Recursion Function C++ Inline function C++ Friend function

C++ Arrays

Single dimension array Two dimension array

C++ Strings

C++ Strings

C++ Inheritance

C++ Inheritance Single level Inheritance Multilevel Inheritance Multiple Inheritance Hierarchical Inheritance Hybrid Inheritance

C++ Polymorphism

C++ Polymorphism C++ Overloading C++ Overriding C++ Virtual Function

C++ Pointers

C++ Pointers C++ this pointer

C++ Exception Handling

C++ Exception Handling

C++ Constructors

C++ Constructors Default Constructor Parameterize Constructor Copy constructor Constructor Overloading Destructor

C++ File Handling

C++ File Handling C++ Writing to file C++ Reading file C++ Close file

Miscellaneous

C Vs C++ C++ Comments C++ Data Abstraction C++ Identifier C++ Memory Management C++ Storage Classes C++ Void Pointer C++ Array To Function C++ Expressions C++ Features C++ Interfaces C++ Encapsulation std::min in C++ External merge sort in C++ Remove duplicates from sorted array in C++ Precision of floating point numbers Using these functions floor(), ceil(), trunc(), round() and setprecision() in C++ C++ References C++ Friend Functions C++ Mutable keyword Unary Operators in C++ Initialize Array of objects with parameterized constructors in C++ Differences between #define & const in C/C++ C++ Program to Implement Shell Sort C++ Program to Implement Merge Sort Storage Classes in C Vector resize() in C++ Passing by Reference Vs. Passing by the pointer in C++ Free vs delete() in C++ goto statement in C and C++ C++ program to read string using cin.getline() C++ String Concatenation Heap Sort in C++ Swap numbers in C++ Input Iterators in C++ Fibonacci Series in C++ C ++ Program: Alphabet Triangle and Number Triangle C++ Program: Matrix Multiplication C++ Program to Print Fibonacci Triangle Stack in C++ Maps in C++ Queue in C++ C++ Bitset C++ Algorithms Priority Queue in C++ C++ Multimap C++ Deque Function Pointer in C++ Sizeof() Operators in C++ C++ array of Pointers free() Vs delete in C Timsort Implementation Using C++ CPP Templates C++ Aggregation C++ Enumeration C++ Math Functions C++ Object Class C++ Queue Initialize Vector in C++ Vector in C++ C++ STL Components Function overloading in C++ C++ Maximum Index Problem C++ find missing in the second array C++ Program to find the product array puzzle C++ Program To Find Largest Subarray With 0 Sum C++ Program To Move All Zeros To The End Of The Array C++ Program to find the element that occurs once C++ Program to find the largest number formed from an array Constructor Vs Destructor C++ Namespaces C++ OOPs Concept C++ Static C++ Structs C++ Try-Catch C++ User Defined Exceptions C++ Virtual Destructor C++ vs C# Malloc() and new in C++ Palindrome Number Program in C++ Snake Code in C++ Splitting a string in C++ Structure Vs Class in C++ Virtual Function Vs Pure Virtual Function C++ Bidirectional Iterators C++ Forward Iterators C++ Iterators C++ Output Iterators C++ Range-based For Loop Converting string into integer in C++ LCM Program in C++ Type conversion in C++ Add two numbers using the function in C++ Advantage and disadvantage friend function C++ Armstrong Number Program in C++ ATM machine program in C++ using functions Binary to Decimal in C++ Bit Manipulation in C++ C++ Constructor C++ Dijkstra Algorithm Using the Priority Queue C++ int into String C++ Signal Handling Decimal to Binary in C++ Decimal to Hexadecimal in C++ Decimal to Octal in C++ Factorial Program in C++ Function in C++ Hexadecimal to Decimal in C++ Octal to Decimal in C++ Reverse a Number in C++ Structure Vs Class in C++ C++ Forward Iterators C++ Output Iterators C++ Prime number program Char Array to String in C++ Constructor Overloading in C++ Default arguments in C++ Different Ways to Compare Strings in C++ Dynamic Binding in C++ Program to convert infix to postfix expression in C++ SET Data Structure in C++ Upcasting and Downcasting in C++ Reverse an Array in C++ Fast Input and Output in C++ Delete Operator in C++ Copy elision in C++ C++ Date and Time C++ Bitwise XOR Operator Array of sets in C++ Binary Operator Overloading in C++ Binary Search in C++ Implementing the sets without C++ STL containers Scope Resolution Operator in C++ Smart pointers in C++ Types of polymorphism in C++ Exception Handling in C++ vs Java Const Keyword in C++ Type Casting in C++ Static keyword in C++ vs Java Inheritance in C++ vs Java How to concatenate two strings in C++ Programs to Print Pyramid Patterns in C++ swap() function in C++ Structure of C++ Program Stringstream in C++ and its applications rand() and srand() in C / C++ C++ Ternary Operator C++ Scope of Variables While Loop Examples in C++ Star pattern in C++ using For Loops For Loop Examples in C++ Do-While Loop Examples in C++ Top 5 IDEs for C++ That You Should Try Once Assertions in C/C++ C++ Convert Int to String Continue in C++ While loop Diamond Pattern in C++ using For Loop How to Reverse a String in C++ using Do-While Loop How to Reverse a String in C++ using For Loop How to Reverse a String in C++ using While Loop Infinite loop in C++ Loops in C++ Returning Multiple Values from a Function using Tuple and Pair in C++ wcscpy(), wcslen(), wcscmp() Functions in C++ Auto keyword in C++ C++ 11 vs C++ 14 vs C++ 17 C++ STL (Standard Template Library) Differences Between C Structures and C++ Structures Divide by Zero Exception in C++ Dynamic Constructor in C++ Dynamic Memory Allocation in C++ Find the Size of Array in C/C++ without using sizeof() function Floating Point Operations and Associativity in C, C++ and Java Hello World Program in C++ How to create a table in C++ How to Setup Environment for C++ Programming on Mac Implementation of a Falling Matrix in C++ Message Passing in C++ Pointer to Object in C++ Templates in C++ vs Generics in Java Ways to Copy a Vector in C++ What does Buffer Flush mean in C++ sort() function in C++ Structure Sorting (By Multiple Rules) in C++ Similarities between C++ and Java std::distance in C++

C++ Try-Catch

Every useful program will eventually encounter unexpected outcomes. By entering data that are incorrect, users might create mistakes. Sometimes the program's creator didn't consider all of the options or was unaware of forthcoming developments in the libraries.

C++ provides a try-catch construct that is designed to handle unexpected errors like these, regardless of the reason. Let's start with exceptions to learn how try-catch works in C++.

Exceptions in C++:

When executing the C++ code, various different problems may occur like programming errors or the errors because of incorrect input or many more other kinds of errors.

C++ will basically stand still and will show an error message when any kind of error  will occur. C++ will produce an exception, which is the technical phrase for throwing an error.

In C++, what is Exception Handling?

In C++, Exception handling allows you to deal with unexpected events such as runtime failures. As a result, if an unexpected event happens, control of the program is passed to special functions known as handlers.

You put a piece of code underneath exception inspection to catch the exceptions. The code is contained inside the try-catch block.

An exception will be triggered if an unusual scenario happens inside that portion of code. The program will then be taken over by the exception handler.

If no unexpected circumstances arise, the code will run normally. The handlers will indeed be forgotten about.

Applying exception handlers into your application has no performance impact; if no exceptions are triggered, the handlers will never be called. Leaving exception handlers out of your code makes it more vulnerable.

Exception handling is one notable distinction between the C and C++ programming languages, despite their numerous similarities. In C, exception handlers and its ability to respond to them do not exist, therefore programmers are obliged to arrange exceptions out from their code instead of being capable of reacting to them as they occur.

Why do we use Exception Handling?

The following are some of the reasons why you should use Exception Handling in C++:

  • You'll keep your error-handling code distinct from the rest of your code. It would further be feasible for user to read/maintain the programming code.
  • Exceptions could be handled by the functions if they want. Even though a function throws a large number of exceptions, this will only handle a portion of them. Uncaught exceptions will be handled by the caller.

Keywords for Exception Handling:

The three keywords that govern exception handling in C++ are:

Throw- When a program runs into a difficulty, it will throw an exception. The throw keyword assists the program in throwing action.

Catch- An exception handler is used by a program to catch an exception. It's added to the area of a program where you'll be dealing with the issue. The catch keyword is used to do this.

Try- The try block indicates the piece of code for which exceptions will be raised. One or more catch blocks should be placed after it.

Assume a code block throws an exception. A method employing try and catch keywords will catch the exception. Code that may raise an exception should be included in a try/catch block. Protected code is the term for this type of code.

Syntax:

The syntax for try/catch is as follows:

try {
   // code(protected)
} catch( Exceptions_Name excptn1 ) {
   // catch-block
} catch( Exceptions_Name excptn2 ) {
   // catch-block
} catch( Exceptions_Name excptnN ) {
   // catch-block
}

We can have several catch statements even if we only have one try statement.

The identifier of an exception to be captured is Exceptions_Name.

The exceptions are referred to by the identifiers excptn1, excptn2 and excptnN, which you create.

Example A:

#include<iostream>
#include<vector>
using namespace std;


int main() {
	vector<int> vect;
	vect.push_back(0);	
	vect.push_back(1);	
	// accessing third element, which is non-existence
	try
	{
		vect.at(2);		
	}
	catch (exception& exc)
	{
		cout << "Exception has occurred!" << endl;
	}
	return 0;
}

Output:

Exception has occurred!

Explanation:

We defined a vector named vect to store an integer value. Then added elements 0 and 1 to the vector vect. We used a try statement in order to catch an exception and the data inside the body will be protected. Then we tried accessing the element which was at index 2 but could not as there was no element existing at that index value. Then the catch keyword catches the exception and stores it in the variable exc and prints the required output.

Example B:

#include <iostream>
using namespace std;
double zeroDiv(int a, int b) {


	if (b == 0) {
		throw "The Division was done by Zero!";
	}
	return (a / b);
}


int main() {
	int i = 17;
	int j = 0;
	double k = 0;


	try {
		k = zeroDivision(i, j);
		cout << k << endl;
	}
	catch (const char* msg) {
		cerr << msg << endl;
	}
	return 0;
}

Output:

The Division was done by Zero!

Explanation:

We created a function zeroDiv which further will intake two integer values a and b and will return the double value in variable c. Then an if statement was defined to check if the b variable in 0 or not and if it is 0 then return a specific message. Then in the main() function we defined variables i, j and k and provided their values. The try keyword was used to catch an exception and the code inside that was protected. Then with the keyword catch, the exception will be caught and the error message will be stored in the newly created variable msg. After executing the code successfully, the output required will be displayed.

Inconsistency between the exception defined and the exception thrown:

  • If a catch block defines a type of exception that differs from the kind of exception produced by the try block, the exception remains uncaught, and the catch block is skipped.
  • The uncaught exception is then sent down the call stack to the following procedure. If the following function has a matching catch block, the exception is caught; otherwise, it is pushed down towards the next function.
  • The cycle repeats till a thrown exception enters the main() function (where it all began). The call stack bursts and the application dies suddenly if there is no corresponding catch block inside the main() method.

Standard Exceptions in C++:

The <exception> class in C++ includes a collection of standard exceptions. The following are examples:

C++ try/catch

Fig. Standard Exceptions

std::exception

This is the parent class of all standardized C++ exceptions and is an exception.

std::bad_alloc

A new keyword throws this exception.

std::bad_cast

Dynamic cast throws an exception in this case.

std::bad_exception

In C++ applications, this is a helpful technique for managing unexpected exceptions.

std::bad_typeid

typeid throws an exception.

std::logic_error

Reading code should be able to identify this exception.

std::domain_error

This error will be shown when any kind of incorrect mathematical domain will be used.

std::invalid_argument

When incorrect parameters are used, an exception is raised.

std::length_error

After constructing a large std:string, an error was fired

std::out_of_range

Method has been thrown.

std::runtime_error

An exception that can't be found by looking at the code.

std::overflow_error

This error is issued when a mathematical overflow occurs.

std::range_error

When you try to save an out-of-range value, an exception is raised.

std::underflow_error

When there is a mathematical underflow, an exception is thrown.

User-Defined C++ Exceptions:

We may construct objects which can be thrown as exceptions using the C++ std::exception class. The <exception> header contains the definition of this class. The function what() is provided by the class and is a virtual member function.

This method returns a char * character sequence that is null-terminated. To get an exception description, we can rewrite it in derived classes.

Example:

#include <iostream>
#include <exception>
using namespace std;


class newExcptn : public excptn
{
	virtual const char* what() const throw()
	{
		return "newExcptn occurred";
	}
} newexc;


int main() {


	try {
		throw newexc;
		}
	catch (exception& exc) {
		cout << exc.what() << '\n';
	}
	return 0;	
}

Output:

newExcptn occurred

Explanation:

We created a new class newExcptn which inherits the C++ exception class. What() virtual member function which was defined in the header file of exception, will be overwritten by our new exception. The newexc is the variable used to catch the new exception and once it is caught the newExcptn will get executed. Then in the main() function, the try keyword will be used to try and catch the exception and the code written inside that will be protected. If the exception will be caught then the newexc will be thrown using the keyword throw. The catch keyword will be used to catch the exception and that caught exception’s error message will be stored in the exc variable and the error message will be printed as output.

Conclusion:

  • You can manage runtime faults via exception handling in C++.
  • Exception handling allows you to deal with any unforeseen situations that arise in your software.
  • When an unexpected event happens, control of the program is passed to handlers.
  • A chunk of code is placed underneath the try-catch block to capture an exception.
  • The throw keyword allows the program to throw exceptions, which helps it deal with the situation.
  • The try keyword is mainly used to specify the piece of code in which the exceptions will be raised.
  • To specify our exceptions, we may replace the what() method in the exception header file.



ADVERTISEMENT
ADVERTISEMENT